<script>
export default {
  props: {
      todos: Array
  },
  setup(props) {

    const toggleDone = todo => todo.done = !todo.done
    const removeTodo = index => props.todos.splice(index, 1)
    const markAllDone = () => props.todos.forEach(todo => todo.done = true)
    const editTodo = index => props.todos.splice(index, 1)
    const removeAllTodos = () => {
     props.todos.splice(0)
      console.log("Tareas:", props.todos)
    }
    return {
      toggleDone,
      removeTodo,
      markAllDone,
      removeAllTodos
    }
  }
}
</script>

<template>
  <div className="w-1/2">
      <p className="text-2xl mt-10 text-center">
        <span className="text-indigo-600 font-bold mb-10">Listado de tareas</span>
      </p> 
      <div className="bg-white shadow-md rounded-lg py-10 px-5 m-5">
        <ul>
        <li v-for="(todo, index) in todos" :key="todo.id">
          <div className="flex">
            <div className="w-4/6">
              <p :class="{ done: todo.done}" className="ml-12 p-2 uppercase font-bold" @click="toggleDone(todo)">{{todo.content}}</p>
            </div>
            <div className="w-1/6">
              <button 
                className="m-1 p-1 px-4 bg-red-500 text-white uppercase font-bold hover:bg-red-700 rounded-md"
                @click="editTodo(index)"
              >
                Editar
              </button>
            </div>
            <div className="w-1/6">
              <button 
                className="m-1 p-1 px-4 bg-blue-500 text-white uppercase font-bold hover:bg-blue-700 rounded-md"
                @click="removeTodo(index)"
              >
                Eliminar
              </button>
            </div>            
          </div>
        </li>
      </ul>
          <div className="mt-5 flex mb-12">
            <div className="w-1/2 m-2">
              <button
                  className="bg-green-600 w-full p-3 text-white uppercase font-bold hover:bg-green-700 rounded-md"
                  @click="markAllDone"
              >
                  Marcas todas
              </button>
            </div>
            <div className="w-1/2 m-2">
              <button
                  className="bg-red-500 w-full p-3 text-white uppercase font-bold hover:bg-red-700 rounded-md"
                  @click="removeAllTodos"
              >
                  Eliminar todas
              </button>
            </div>
          </div>
      </div>      
  </div>
</template>

<style scoped>
  .done {
    text-decoration: line-through;
  }
</style>